// AdvOptionsPage.cpp : implementation file
//

#include "stdafx.h"
#include "magic.h"
#include "AdvOptionsPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdvOptionsPage property page

IMPLEMENT_DYNCREATE(CAdvOptionsPage, CPropertyPage)

CAdvOptionsPage::CAdvOptionsPage() : CPropertyPage(CAdvOptionsPage::IDD)
{
	//{{AFX_DATA_INIT(CAdvOptionsPage)
	m_bLog = (theApp.m_dwFlags & MMF_LOG_DELETED)!=0;
	m_nLogSize = theApp.m_nMaxLogSize;
	m_bColor = (theApp.m_dwFlags & MMF_COLOR_FRIEND)!=0;
	m_bSingle = (theApp.m_dwFlags & MMF_SINGLE)!=0;
	//}}AFX_DATA_INIT
	m_clrFriend = theApp.m_clrFriends;
}

CAdvOptionsPage::~CAdvOptionsPage()
{
}

void CAdvOptionsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvOptionsPage)
	DDX_Control(pDX, IDC_CLR_SAMPLE, m_Sample);
	DDX_Check(pDX, IDC_LOG_DEL, m_bLog);
	DDX_Text(pDX, IDC_MAX_LOG, m_nLogSize);
	DDX_Check(pDX, IDC_FRIEND_COLOR, m_bColor);
	DDX_Check(pDX, IDC_SINGLE, m_bSingle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdvOptionsPage, CPropertyPage)
	//{{AFX_MSG_MAP(CAdvOptionsPage)
	ON_BN_CLICKED(IDC_CLR_BRS, OnClrBrs)
	ON_BN_CLICKED(IDC_FRIEND_COLOR, OnFriendColor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdvOptionsPage message handlers

BOOL CAdvOptionsPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	DlgTranslate(this);
	
	m_Sample.SetColor(!m_bColor, m_clrFriend);

	return TRUE;
}

BOOL CAdvOptionsPage::OnApply() 
{
	if (m_bLog)
		theApp.m_dwFlags |= MMF_LOG_DELETED;
	else
		theApp.m_dwFlags &= ~MMF_LOG_DELETED;

	theApp.m_nMaxLogSize = m_nLogSize;
	if (m_bColor)
		theApp.m_dwFlags |= MMF_COLOR_FRIEND;
	else
		theApp.m_dwFlags &= ~MMF_COLOR_FRIEND;
	if (m_bSingle)
		theApp.m_dwFlags |= MMF_SINGLE;
	else
		theApp.m_dwFlags &= ~MMF_SINGLE;
	theApp.m_clrFriends = m_clrFriend;
	
	return TRUE;
}

void CAdvOptionsPage::OnClrBrs() 
{
	UpdateData();
	CColorDialog dlg(m_clrFriend);
	if (dlg.DoModal()!=IDOK)
		return;
	m_clrFriend = dlg.GetColor();
	m_Sample.SetColor(!m_bColor, m_clrFriend);
}

void CAdvOptionsPage::OnFriendColor() 
{
	UpdateData();
	m_Sample.SetColor(!m_bColor, m_clrFriend);
}
